import 'package:flutter/material.dart';
import 'package:sem_search/pagination/pagination.dart';
import 'package:sem_search/search_box/search_box.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key? key, required this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  List results = [];
  List result = [];
  GlobalKey<SearchBox> _myKey = GlobalKey();
  GlobalKey<SearchBox> _myKey1 = GlobalKey();

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Column(
        children: <Widget>[
          ZirSearchBox(
            key: _myKey,
            apiKey: 'zqt_cKg6-jmMWbiFViZw_6fEPl2JITLhXVk0jg3TQg',
            corpusId: [234],
            customerId: "1890073338",
            image: "assets/logo.png",
            results: 20,
            offset: 0,
            callback: (value) {
              setState(() {
                results = value['response'];
              });
            },
          ),
          Container(
            width: 400,
            child: Row(
              children: [
                ActionChip(
                    label: Text("response"),
                    onPressed: () async {
                      final res =
                          await _myKey.currentState!.runSearch("response");
                      setState(() {
                        results = res['response'];
                      });
                    }),
                ActionChip(
                    label: Text("review"),
                    onPressed: () async {
                      final res =
                          await _myKey.currentState!.runSearch("review");
                      setState(() {
                        results = res['response'];
                      });
                    }),
              ],
            ),
          ),
          Container(
            margin: EdgeInsets.only(left: 8),
            child: ZirPagination(searchKey: _myKey),
          ),
          Container(
            width: 400,
            child: results.length == 0
                ? Container(
                    child: Text("no results"),
                    margin: EdgeInsets.only(left: 8),
                  )
                : ListView.builder(
                    itemCount: results.length,
                    scrollDirection: Axis.vertical,
                    shrinkWrap: true,
                    itemBuilder: (context, i) {
                      return Container(
                        child: ListTile(
                            title: Text(
                          results[i]["text"],
                          style: TextStyle(color: Colors.white),
                        )),
                        margin: EdgeInsets.only(bottom: 5),
                        decoration: BoxDecoration(
                          color: Colors.blue,
                          borderRadius: BorderRadius.circular(10),
                        ),
                      );
                    },
                  ),
          ),
          ZirSearchBox(
            key: _myKey1,
            apiKey: 'zqt_cKg6-jmMWbiFViZw_6fEPl2JITLhXVk0jg3TQg',
            corpusId: [234],
            customerId: "1890073338",
            image: "assets/logo.png",
            results: 10,
            offset: 10,
            callback: (value) {
              setState(() {
                result = value['response'];
              });
            },
          ),
          Container(
            margin: EdgeInsets.only(left: 4),
            child: ZirPagination(searchKey: _myKey1),
          ),
          Container(
            width: 400,
            child: result.length == 0
                ? Container(
                    child: Text("no results"),
                    margin: EdgeInsets.only(left: 4),
                  )
                : ListView.builder(
                    itemCount: result.length,
                    scrollDirection: Axis.vertical,
                    shrinkWrap: true,
                    itemBuilder: (context, i) {
                      return Container(
                        child: ListTile(
                            title: Text(
                          result[i]["text"],
                          style: TextStyle(color: Colors.white),
                        )),
                        margin: EdgeInsets.only(bottom: 5),
                        decoration: BoxDecoration(
                          color: Colors.blue,
                          borderRadius: BorderRadius.circular(10),
                        ),
                      );
                    },
                  ),
          ),
        ],
      ),
    );
  }
}

