import "package:flutter/material.dart";

class PaginationButton extends StatefulWidget {
  final value;
  final handler;
  final widget;
  final active;
  PaginationButton({this.value, this.handler, this.widget, this.active});

  @override
  Button createState() => new Button();
}

class Button extends State<PaginationButton> {
  @override
  Widget build(BuildContext context) {
    return Container(
      width: 30,
      child: Padding(
        padding: EdgeInsets.only(right: 4),
        child: MaterialButton(
            disabledElevation: 0,
            hoverColor: Colors.red,
            splashColor: Colors.transparent,
            focusColor: Colors.transparent,
            height: 30,
            minWidth: 30,
            color: widget.active != null && widget.active
                ? Colors.blue
                : Colors.white,
            textColor: widget.active != null && widget.active
                ? Colors.white
                : Colors.black,
            shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(2.0),
                side: BorderSide(color: Colors.grey)),
            padding: EdgeInsets.all(0),
            onPressed: () {
              widget.handler(widget.value);
            },
            child: widget.widget),
      ),
    );
  }
}
