import "package:flutter/material.dart";
import 'button.dart';
import "pagination_helpers.dart";

class ZirPagination extends StatefulWidget {
  final searchKey;
  ZirPagination({this.searchKey});

  @override
  Pagination createState() => new Pagination();
}

class Pagination extends State<ZirPagination> {
  num page = 0;
  num pageLength = 5;
  var pageHelper = new PaginationHelper();
  num count = 0;
  List pages = [];

  @override
  void initState() {
    super.initState();

    setState(() {
      count = pageHelper.getPagesCount(
          pageLength * widget.searchKey.currentState.results,
          widget.searchKey.currentState.results);
      pages = pageHelper.getPages(page + 1, count, 5);
    });
  }

  updateState() {
    if (page >= 3 &&
        widget.searchKey.currentState.length ==
            widget.searchKey.currentState.results) {
      setState(() {
        pageLength = pageLength + widget.searchKey.currentState.results;
        count = pageHelper.getPagesCount(
            pageLength * widget.searchKey.currentState.results,
            widget.searchKey.currentState.results);
        pages = pageHelper.getPages(page + 1, count, 5);
      });
    }
    widget.searchKey.currentState.handleQuery();
  }

  _runPrevious(int n) {
    if (page > 0) {
      num p = page - 1;
      setState(() {
        page = p;
      });
      widget.searchKey.currentState
          .changeOffset((p) * widget.searchKey.currentState.results);
      updateState();
    }
  }

  _runNext(num a) {
    if (page < count - 1) {
      num p = page + 1;
      setState(() {
        page = p;
      });
      widget.searchKey.currentState
          .changeOffset((p) * widget.searchKey.currentState.results);
      updateState();
    }
  }

  _runSelected(int pageNum) {
    if(pageNum > page + 1 && widget.searchKey.currentState.length == widget.searchKey.currentState.results){
    num p = pageNum - 1;
    setState(() {
      page = p;
    });
    widget.searchKey.currentState
        .changeOffset((p) * widget.searchKey.currentState.results);
      updateState();
    } else if (page >= pageNum) {
       num p = pageNum - 1;
      setState(() {
        page = p;
        count = pageHelper.getPagesCount(
            pageLength * widget.searchKey.currentState.results,
            widget.searchKey.currentState.results);
        pages = pageHelper.getPages(p, count, 5);
      });
      widget.searchKey.currentState
          .changeOffset((p) * widget.searchKey.currentState.results);
      updateState();
    }
  }

  @override
  Widget build(BuildContext context) {
    return Row(children: [
      PaginationButton(
          widget: Icon(Icons.arrow_back, size: 10),
          value: 0,
          handler: _runPrevious),
      PaginationButton(
          widget: Text("1"),
          value: 1,
          active: page == 0 ? true : false,
          handler: _runSelected),
      Visibility(
          child: Padding(
              padding: EdgeInsets.only(left: 4, right: 4), child: Text("...")),
          visible: page > 3 && widget.searchKey.currentState.length > 0),
      Container(
          child: Row(
              children: pages.map((e) {
            return PaginationButton(
                widget: Text("$e"),
                active: page + 1 == e ? true : false,
                value: e,
                handler: _runSelected);
          }).toList())),
      PaginationButton(
          // widget: Icon(Icons.arrow_forward, size: 10),
          widget: Icon(
            Icons.arrow_forward,
            size: 10,
          ),
          value: 0,
          handler: _runNext),
    ]);
  }
}
